<?php

namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\Sm00001002DocumentoPropostaIdiomaFactory;
use Teknisa\SM\Service\SmDocumentosService;

class Sm00001002DocumentoPropostaIdiomaService {

    protected $docIdiomaFactory;
    protected $smDocumentosService;
    protected $fileServerBaseUrl;

    public function __construct(Sm00001002DocumentoPropostaIdiomaFactory $docIdiomaFactory, SmDocumentosService $smDocumentosService, $fileServerBaseUrl) {
        $this->docIdiomaFactory    = $docIdiomaFactory;
        $this->smDocumentosService = $smDocumentosService;
        $this->fileServerBaseUrl   = $fileServerBaseUrl;
    }

    public function downloadDocFileServer($nrorcamentodocidioma, $nrorg) {
        $result = null;
        $documento = $this->getDocumentoPropostaIdioma($nrorcamentodocidioma);
        
        if (!empty($documento["DSCAMINHOARQ"])) {
            $microtime = microtime(true);
            $microtime = str_replace(".", "_", $microtime);
            
            $fileDir   = $this->fileServerBaseUrl . $documento["DSCAMINHOARQ"];
            $fileName  = $microtime . "_" . str_replace(",", "_", $documento["NMARQUIVO"]);
            
            $this->smDocumentosService->downloadDocFileServer($fileDir, $fileName, $nrorg);
            $fileName = base64_encode($fileName);
            $result = "/downloadArquivo?requestType=Row&row[FILENAME]=" . $fileName . "&row[FILETYPE]=" . $documento["DSTIPO"];
        }
        
        return $result;
    }

    public function getDocumentoPropostaIdioma($nrorcamentodocidioma) {
        $params = [
            "NRORCAMENTODOCIDIOMA" => $nrorcamentodocidioma
        ];
        $dataset = $this->docIdiomaFactory->getDocumentoPropostaIdioma($params);
        return $dataset[0];
    }

    public function limparCamposAnexo($nrorcamentodocidioma, $nrorg, $cdoperador) {
        $params = [
            "NRORGULTATU"          => $nrorg,
            "CDOPERULTATU"         => $cdoperador,
            "NRORCAMENTODOCIDIOMA" => $nrorcamentodocidioma
        ];

        $this->docIdiomaFactory->limparCamposAnexo($params);
    }
}