/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_TIPOLAUDO                                                */
/* Tabela : TIPOLAUDO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOLAUDO'  and
            type = 'TR'                       and
            u.uid = o.uid                     and
            u.name = USER)
  DROP TRIGGER DTULTATU_TIPOLAUDO
  GO

CREATE TRIGGER DTULTATU_TIPOLAUDO
ON TIPOLAUDO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'TIPOLAUDO', NULL, 'CDTIPOLAUDO='+CDTIPOLAUDO+';', GETDATE() FROM DELETED);
   END
   ELSE BEGIN
      UPDATE TIPOLAUDO
      SET DTULTATUTLAU = GETDATE()
      FROM INSERTED
      WHERE
         (TIPOLAUDO.CDTIPOLAUDO = INSERTED.CDTIPOLAUDO)
   END;
END;
GO
