IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CONSULTA_CFOP' AND
	              TYPE = 'P' 			      AND
      	        U.UID = O.UID            AND
      	        U.NAME = USER)
DROP PROCEDURE CONSULTA_CFOP
GO
CREATE PROCEDURE CONSULTA_CFOP @P_ENTSAICFOP  VARCHAR(01),
                               @P_EMPRESA     VARCHAR(02),
                               @P_CDARVPROD   VARCHAR(20),
                               @P_INSCESTA    VARCHAR(16),
                               @P_TIPOOPER    VARCHAR(02),
                               @P_PAISORIG    VARCHAR(04),
                               @P_ESTAORIG    VARCHAR(02),
                               @P_PAISDEST    VARCHAR(04),
                               @P_ESTADEST    VARCHAR(02),
                               @P_FILIAL      VARCHAR(04),
                               @P_LANCTONF    VARCHAR(10),
                               @P_CDGRUPOFISC VARCHAR(03),
                               @P_DTVALIDCFOP DATETIME,
                               @P_IDORIGEMPROD VARCHAR(01) = 'N'
AS
   DECLARE @V_SEQUENCIA     VARCHAR(02);
   DECLARE @V_CFOP1DIGT     VARCHAR(01);
   DECLARE @V_CDARVPROD     VARCHAR(20);
   DECLARE @V_CONTADOR      INTEGER;
   DECLARE @V_CDFISCOPER    VARCHAR(10);
   DECLARE @V_DSCDFISCOPER  VARCHAR(50);
   DECLARE @V_CDSUFXCFOP    VARCHAR(03);
   DECLARE @V_DSMENSCFOP    VARCHAR(120);
   DECLARE @V_DTVALIDCFOP   DATETIME;
   DECLARE @V_CDGRUPOFISC   VARCHAR(03)
   DECLARE @V_IDDIFEALIQ    VARCHAR(01);
   DECLARE @V_COUNTMENS       INTEGER;
   DECLARE @V_CDMENSAGEM      VARCHAR(03);
   DECLARE @V_IDINTEREST    VARCHAR(01);
   DECLARE @V_IDDIFALIQCUSPR  VARCHAR(01);

   DECLARE @V_EXISTE INTEGER;
   DECLARE @V_REGRA_CDREGRAFISC VARCHAR(10);
   DECLARE @V_REGRA_CDFISCOPER  VARCHAR(10);
   DECLARE @V_REGRA_IDDIFEALIQ  VARCHAR(01);
   DECLARE @V_REGRA_IDDIFALIQCUSPR VARCHAR(01);
   DECLARE @V_DESCRICAOCFOP     VARCHAR(50);
   DECLARE @V_CFOP              VARCHAR(10);
   DECLARE @V_REGRA_IDTIPOREGISTRO VARCHAR(04);
   DECLARE @V_REGRA_IDMENSAGEM     VARCHAR(01);
   DECLARE @V_REGRA_CDCLASFISC     VARCHAR(10);
   DECLARE @V_REGRA_IDCFOPINTEREST VARCHAR(01);
   DECLARE @V_REGRA_CDPRODUTO      VARCHAR(10);
   DECLARE @V_MSGREGRA_DSMENSAGEM VARCHAR(120);
BEGIN
   SET @V_CDGRUPOFISC   = NULL;
   SET @V_CDARVPROD     = NULL;
   SET @V_CONTADOR      = 0;
   SET @V_IDINTEREST    = 'N';

   DELETE FROM CFOPTEMP
   WHERE NRCFOPTEMP = @P_FILIAL+@P_LANCTONF;

  	IF (@P_ENTSAICFOP = 'E') BEGIN
     	IF (@P_PAISORIG = @P_PAISDEST) BEGIN
      	IF (@P_ESTAORIG = @P_ESTADEST) BEGIN
        		SET @V_CFOP1DIGT = '1';
         END
       	ELSE BEGIN
         	SET @V_CFOP1DIGT = '2';
            SET @V_IDINTEREST    = 'S';
      	END;
      END
    	ELSE BEGIN
      	SET @V_CFOP1DIGT = '3';
         SET @V_IDINTEREST    = 'S';
    	END;
   END
   ELSE BEGIN
		IF @P_PAISORIG = @P_PAISDEST BEGIN
			IF @P_ESTAORIG = @P_ESTADEST BEGIN
				SET @V_CFOP1DIGT = '5';
         END
       	ELSE BEGIN
        		SET @V_CFOP1DIGT = '6';
            SET @V_IDINTEREST    = 'S';
       	END;
      END
    	ELSE BEGIN
			SET @V_CFOP1DIGT = '7';
         SET @V_IDINTEREST    = 'S';
    	END;
   END;

   SET @V_SEQUENCIA = '01';

/* Retorna o grupo fiscal para as operaes interestaduais */
   IF @V_CFOP1DIGT = '2' OR
      @V_CFOP1DIGT = '6' BEGIN
      SELECT @V_CDGRUPOFISC = SUBSTRING(DSPARGERFIS,3,3)
      FROM PARAMGERAL;

      SET @V_IDINTEREST    = 'S';
   END;

   IF (@V_CDGRUPOFISC IS NULL) or (@V_CDGRUPOFISC = '') BEGIN
      SET @V_CDGRUPOFISC = @P_CDGRUPOFISC;
   END;

   DECLARE C_REGRA CURSOR FOR
      SELECT DISTINCT CDREGRAFISC, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, IDTIPOREGISTRO, IDMENSAGEM, CDCLASFISC, IDCFOPINTEREST, CDPRODUTO
        FROM TEKNISA.CONSULTA_REGRA_FISCAL(null, @P_EMPRESA, @V_CDGRUPOFISC, @P_ENTSAICFOP, @P_TIPOOPER, @P_INSCESTA, @P_CDARVPROD, @P_DTVALIDCFOP,
                                           @P_PAISORIG, @P_ESTAORIG, NULL, @P_PAISDEST, @P_ESTADEST, NULL, 0, 'S', @P_IDORIGEMPROD)
       WHERE CDFISCOPER IS NOT NULL;                                        
   OPEN C_REGRA;
   FETCH NEXT FROM C_REGRA INTO @V_REGRA_CDREGRAFISC, @V_REGRA_CDFISCOPER, @V_REGRA_IDDIFEALIQ, @V_REGRA_IDDIFALIQCUSPR, @V_REGRA_IDTIPOREGISTRO, @V_REGRA_IDMENSAGEM,
                                @V_REGRA_CDCLASFISC, @V_REGRA_IDCFOPINTEREST, @V_REGRA_CDPRODUTO;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (@V_REGRA_CDFISCOPER IS NOT NULL) BEGIN
         SET @V_CFOP = @V_CFOP1DIGT+@V_REGRA_CDFISCOPER;

         SELECT @V_DESCRICAOCFOP = TEKNISA.DESCRICAO_CFOP (@V_CFOP);
         IF @V_REGRA_IDMENSAGEM = 'S' BEGIN
            IF @V_REGRA_IDTIPOREGISTRO = 'PAD' BEGIN
               DECLARE C_MSGREGRA CURSOR FOR
                  SELECT DSMENSAGEM
                    FROM MSGCFOPADRAO
                   WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                     AND IDCFOPINTEREST = @V_REGRA_IDCFOPINTEREST;
               OPEN C_MSGREGRA;
               FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  INSERT INTO CFOPTEMP
                     (NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                      DSCFOPTMP, DSMENSCFOTMP, DTVDCFOPTMP, IDDIFALIQTMP,
                      IDDIFALIQCUSPRC, CDREGRATMP)
                  VALUES
                     (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_CFOP1DIGT+@V_REGRA_CDFISCOPER, NULL,
                      @V_DESCRICAOCFOP, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_IDDIFEALIQ,
                      @V_REGRA_IDDIFALIQCUSPR, @V_REGRA_CDREGRAFISC);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);
                  FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
               END;
               CLOSE C_MSGREGRA;
               DEALLOCATE C_MSGREGRA;
            END
            ELSE BEGIN
               IF @V_REGRA_IDTIPOREGISTRO = 'NCM' BEGIN
                  DECLARE C_MSGREGRA CURSOR FOR
                     SELECT DSMENSAGEM
                       FROM MSGCFOPNCM
                      WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                        AND CDCLASFISC = @V_REGRA_CDCLASFISC
                        AND IDCFOPINTEREST = @V_REGRA_IDCFOPINTEREST;
                  OPEN C_MSGREGRA;
                  FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     INSERT INTO CFOPTEMP
                        (NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                         DSCFOPTMP, DSMENSCFOTMP, DTVDCFOPTMP, IDDIFALIQTMP,
                         IDDIFALIQCUSPRC, CDREGRATMP)
                     VALUES
                        (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_CFOP1DIGT+@V_REGRA_CDFISCOPER, NULL,
                         @V_DESCRICAOCFOP, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_IDDIFEALIQ,
                         @V_REGRA_IDDIFALIQCUSPR, @V_REGRA_CDREGRAFISC);

                     SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);
                     FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                  END;
                  CLOSE C_MSGREGRA;
                  DEALLOCATE C_MSGREGRA;
               END
               ELSE BEGIN
                  IF @V_REGRA_IDTIPOREGISTRO = 'PROD' BEGIN
                     DECLARE C_MSGREGRA CURSOR FOR
                        SELECT DSMENSAGEM
                          FROM MSGCFOPREGFISC
                         WHERE CDREGRAFISC = @V_REGRA_CDREGRAFISC
                           AND CDPRODUTO = @V_REGRA_CDPRODUTO
                           AND IDCFOPINTEREST = @V_REGRA_IDCFOPINTEREST;
                     OPEN C_MSGREGRA;
                     FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        INSERT INTO CFOPTEMP
                           (NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                            DSCFOPTMP, DSMENSCFOTMP, DTVDCFOPTMP, IDDIFALIQTMP,
                            IDDIFALIQCUSPRC, CDREGRATMP)
                        VALUES
                           (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_CFOP1DIGT+@V_REGRA_CDFISCOPER, NULL,
                            @V_DESCRICAOCFOP, @V_MSGREGRA_DSMENSAGEM, NULL, @V_REGRA_IDDIFEALIQ,
                            @V_REGRA_IDDIFALIQCUSPR, @V_REGRA_CDREGRAFISC);

                        SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);
                        FETCH NEXT FROM C_MSGREGRA INTO @V_MSGREGRA_DSMENSAGEM;
                     END;
                     CLOSE C_MSGREGRA;
                     DEALLOCATE C_MSGREGRA;
                  END;
               END;
            END;
         END
         ELSE BEGIN
            INSERT INTO CFOPTEMP
               (NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                DSCFOPTMP, DSMENSCFOTMP, DTVDCFOPTMP, IDDIFALIQTMP,
                IDDIFALIQCUSPRC, CDREGRATMP)
            VALUES
               (@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_CFOP1DIGT+@V_REGRA_CDFISCOPER, NULL,
                @V_DESCRICAOCFOP, NULL, NULL, @V_REGRA_IDDIFEALIQ,
                @V_REGRA_IDDIFALIQCUSPR, @V_REGRA_CDREGRAFISC);

            SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);
         END;
      END;
      FETCH NEXT FROM C_REGRA INTO @V_REGRA_CDREGRAFISC, @V_REGRA_CDFISCOPER, @V_REGRA_IDDIFEALIQ, @V_REGRA_IDDIFALIQCUSPR, @V_REGRA_IDTIPOREGISTRO, @V_REGRA_IDMENSAGEM,
                                   @V_REGRA_CDCLASFISC, @V_REGRA_IDCFOPINTEREST, @V_REGRA_CDPRODUTO;
   END;
   CLOSE C_REGRA;
   DEALLOCATE C_REGRA;

   SET @V_EXISTE = 0;

   SELECT @V_EXISTE = COUNT(*)
     FROM CFOPTEMP
    WHERE NRCFOPTEMP = @P_FILIAL+@P_LANCTONF
      AND CDREGRATMP IS NOT NULL;

   IF NOT(@V_EXISTE > 0) BEGIN

      IF @V_IDINTEREST = 'S' BEGIN
         IF (@V_CDGRUPOFISC IS NOT NULL) BEGIN
            IF @P_CDARVPROD IS NOT NULL BEGIN
               SELECT @V_CDARVPROD = MAX(P.CDARVPROD),
                      @V_CONTADOR  = COUNT(*)
               FROM CODFISCOPER C LEFT JOIN PRODUTO P ON
                                 (C.CDPRODUTO   = P.CDPRODUTO)
               WHERE (IDENTSAICFOP = @P_ENTSAICFOP)  AND
                     (CDEMPRESA    = @P_EMPRESA)     AND
                     (CDTIPOOPER   = @P_TIPOOPER)    AND
                     (CDINSCESTA   = @P_INSCESTA)    AND
                     (CDGRUPOFISC  = @V_CDGRUPOFISC) AND
                     (IDCFOPINTEREST = 'S')          AND
                     (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),@P_CDARVPROD),@P_CDARVPROD) = 1);
            END
            ELSE BEGIN
               SELECT @V_CDARVPROD = MAX(C.CDPRODUTO),
                      @V_CONTADOR  = COUNT(*)
               FROM CODFISCOPER C
               WHERE (IDENTSAICFOP = @P_ENTSAICFOP)  AND
                     (CDEMPRESA    = @P_EMPRESA)     AND
                     (CDTIPOOPER   = @P_TIPOOPER)    AND
                     (CDINSCESTA   = @P_INSCESTA)    AND
                     (CDGRUPOFISC  = @V_CDGRUPOFISC) AND
                     (IDCFOPINTEREST = 'S')          AND
                     (CDPRODUTO IS NULL);
            END;
         END;

         IF (@V_CONTADOR > 0) BEGIN
            IF (NOT @V_CDARVPROD IS NULL) BEGIN
               DECLARE C_CFOP CURSOR FOR
                  SELECT CDFISCOPER, DSCDFISCOPER, CDSUFXCFOP, DSMENSCFOP,DTVALIDCFOP,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFEALIQ
                                           WHEN '6' THEN IDDIFEALIQ
                                           ELSE NULL END AS IDDIFEALIQ,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFALIQCUSPR
                                           WHEN '6' THEN IDDIFALIQCUSPR
                                           ELSE 'N' END AS IDDIFALIQCUSPR,
                         CDMENSAGEM
                  FROM CODFISCOPER C LEFT JOIN MENSCFOP M ON
                                   (C.NRINCIDCFOP  = M.NRINCIDCFOP)
                                     LEFT JOIN PRODUTO P ON
                                   (C.CDPRODUTO    = P.CDPRODUTO)
                  WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)     AND
                        (C.CDEMPRESA    = @P_EMPRESA)        AND
                        (C.CDTIPOOPER   = @P_TIPOOPER)       AND
                        (C.CDINSCESTA   = @P_INSCESTA)       AND
                        (C.CDGRUPOFISC  = @V_CDGRUPOFISC)    AND
                        (C.IDCFOPINTEREST = 'S')             AND
                        (P.CDARVPROD    = @V_CDARVPROD)      AND
                        (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                            FROM CODFISCOPER C  LEFT JOIN PRODUTO P
                                               ON (C.CDPRODUTO = P.CDPRODUTO)
                                            WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)     AND
                                                  (C.CDEMPRESA    = @P_EMPRESA)        AND
                                                  (C.CDTIPOOPER   = @P_TIPOOPER)       AND
                                                  (C.CDINSCESTA   = @P_INSCESTA)       AND
                                                  (C.CDGRUPOFISC  = @V_CDGRUPOFISC)    AND
                                                  (C.IDCFOPINTEREST = 'S')             AND
                                                  (P.CDARVPROD    = @V_CDARVPROD)      AND
                                                  (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
               OPEN C_CFOP;
               FETCH NEXT FROM C_CFOP INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                           @V_DTVALIDCFOP,  @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                           @V_CDMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSCFOP = NULL;
                  END;

                  INSERT INTO CFOPTEMP(NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                                       DSCFOPTMP, DSMENSCFOTMP, DTVDCFOPTMP, IDDIFALIQTMP,
                                       IDDIFALIQCUSPRC)
                  VALUES(@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA,@V_CFOP1DIGT+@V_CDFISCOPER, @V_CDSUFXCFOP,
                         @V_DSCDFISCOPER, @V_DSMENSCFOP, @V_DTVALIDCFOP, @V_IDDIFEALIQ,
                         @V_IDDIFALIQCUSPR);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_CFOP INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                           @V_DTVALIDCFOP,  @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                           @V_CDMENSAGEM;
               END;
               CLOSE C_CFOP;
               DEALLOCATE C_CFOP;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_CFOPNULL CURSOR FOR
                  SELECT CDFISCOPER, DSCDFISCOPER, CDSUFXCFOP, DSMENSCFOP, DTVALIDCFOP,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFEALIQ
                                           WHEN '6' THEN IDDIFEALIQ
                                           ELSE NULL END AS IDDIFEALIQ,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFALIQCUSPR
                                        WHEN '6' THEN IDDIFALIQCUSPR
                                        ELSE 'N' END AS IDDIFALIQCUSPR,
                         CDMENSAGEM
                  FROM CODFISCOPER C LEFT JOIN MENSCFOP M ON
                       (C.NRINCIDCFOP  = M.NRINCIDCFOP)
                  WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)  AND
                        (C.CDEMPRESA    = @P_EMPRESA)     AND
                        (C.CDTIPOOPER   = @P_TIPOOPER)    AND
                        (C.CDINSCESTA   = @P_INSCESTA)    AND
                        (C.CDGRUPOFISC  = @V_CDGRUPOFISC) AND
                        (C.IDCFOPINTEREST = 'S')          AND
                        (C.CDPRODUTO IS NULL)             AND
                        (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                            FROM CODFISCOPER C
                                            WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)     AND
                                                  (C.CDEMPRESA    = @P_EMPRESA)        AND
                                                  (C.CDTIPOOPER   = @P_TIPOOPER)       AND
                                                  (C.CDINSCESTA   = @P_INSCESTA)       AND
                                                  (C.CDGRUPOFISC  = @V_CDGRUPOFISC)    AND
                                                  (C.IDCFOPINTEREST = 'S')             AND
                                                  (C.CDPRODUTO   IS NULL)             AND
                                                  (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
               OPEN C_CFOPNULL;
               FETCH NEXT FROM C_CFOPNULL INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                               @V_DTVALIDCFOP,  @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                               @V_CDMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSCFOP = NULL;
                  END;

                  INSERT INTO CFOPTEMP(NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                                       DSCFOPTMP, DSMENSCFOTMP, DTVDCFOPTMP, IDDIFALIQTMP,
                                       IDDIFALIQCUSPRC)
                  VALUES(@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_CFOP1DIGT+@V_CDFISCOPER, @V_CDSUFXCFOP,
                         @V_DSCDFISCOPER, @V_DSMENSCFOP, @V_DTVALIDCFOP, @V_IDDIFEALIQ,
                         @V_IDDIFALIQCUSPR);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_CFOPNULL INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                               @V_DTVALIDCFOP,  @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                               @V_CDMENSAGEM;
               END;
               CLOSE C_CFOPNULL;
               DEALLOCATE C_CFOPNULL;
            END;

         END
         ELSE BEGIN
            IF @P_CDARVPROD IS NOT NULL BEGIN
               SELECT @V_CDARVPROD = MAX(P.CDARVPROD)
               FROM CODFISCOPER C LEFT JOIN PRODUTO P ON
                                 (C.CDPRODUTO = P.CDPRODUTO)
               WHERE (IDENTSAICFOP = @P_ENTSAICFOP) AND
                     (CDEMPRESA    = @P_EMPRESA)    AND
                     (CDTIPOOPER   = @P_TIPOOPER)   AND
                     (CDINSCESTA   = @P_INSCESTA)   AND
                     (CDGRUPOFISC IS NULL)          AND
                     (IDCFOPINTEREST = 'S')         AND
                     (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),@P_CDARVPROD),@P_CDARVPROD) = 1);
            END
            ELSE BEGIN
               SELECT @V_CDARVPROD = MAX(C.CDPRODUTO)
               FROM CODFISCOPER C
               WHERE (IDENTSAICFOP = @P_ENTSAICFOP) AND
                     (CDEMPRESA    = @P_EMPRESA)    AND
                     (CDTIPOOPER   = @P_TIPOOPER)   AND
                     (CDINSCESTA   = @P_INSCESTA)   AND
                     (CDGRUPOFISC IS NULL)          AND
                     (IDCFOPINTEREST = 'S')         AND
                     (C.CDPRODUTO IS NULL);
            END;
            IF NOT (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_CFOP CURSOR FOR
                   SELECT CDFISCOPER, DSCDFISCOPER, CDSUFXCFOP, DSMENSCFOP ,DTVALIDCFOP,
                          CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFEALIQ
                                            WHEN '6' THEN IDDIFEALIQ
                                            ELSE NULL END AS IDDIFEALIQ, 
                          CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFALIQCUSPR
                                            WHEN '6' THEN IDDIFALIQCUSPR
                                            ELSE 'N' END AS IDDIFALIQCUSPR,
                          CDMENSAGEM
                   FROM CODFISCOPER C LEFT JOIN MENSCFOP M ON
                                    (C.NRINCIDCFOP  = M.NRINCIDCFOP)
                                      LEFT JOIN PRODUTO P ON
                                    (C.CDPRODUTO = P.CDPRODUTO)
                   WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP) AND
                         (C.CDEMPRESA    = @P_EMPRESA)    AND
                         (C.CDTIPOOPER   = @P_TIPOOPER)   AND
                         (C.CDINSCESTA   = @P_INSCESTA)   AND
                         (C.CDGRUPOFISC IS NULL)          AND
                         (C.IDCFOPINTEREST = 'S')         AND
                         (P.CDARVPROD    = @V_CDARVPROD)  AND
                         (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                            FROM CODFISCOPER C LEFT JOIN PRODUTO P
                                            ON    (C.CDPRODUTO    = P.CDPRODUTO)
                                            WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)     AND
                                                  (C.CDEMPRESA    = @P_EMPRESA)        AND
                                                  (C.CDTIPOOPER   = @P_TIPOOPER)       AND
                                                  (C.CDINSCESTA   = @P_INSCESTA)       AND
                                                  (C.CDGRUPOFISC  IS NULL)             AND
                                                  (C.IDCFOPINTEREST = 'S')             AND
                                                  (P.CDARVPROD    = @V_CDARVPROD)      AND
                                                  (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
               OPEN C_CFOP;
               FETCH NEXT FROM C_CFOP INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                           @V_DTVALIDCFOP, @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                           @V_CDMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSCFOP = NULL;
                  END;

                  INSERT INTO CFOPTEMP(NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                                       DSCFOPTMP, DSMENSCFOTMP,DTVDCFOPTMP, IDDIFALIQTMP,
                                       IDDIFALIQCUSPRC)
                  VALUES(@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_CFOP1DIGT+@V_CDFISCOPER, @V_CDSUFXCFOP,
                         @V_DSCDFISCOPER, @V_DSMENSCFOP, @V_DTVALIDCFOP, @V_IDDIFEALIQ,
                         @V_IDDIFALIQCUSPR);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_CFOP INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                              @V_DTVALIDCFOP, @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                              @V_CDMENSAGEM;
               END;
               CLOSE C_CFOP;
               DEALLOCATE C_CFOP;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_CFOPNULL CURSOR FOR
                  SELECT CDFISCOPER, DSCDFISCOPER, CDSUFXCFOP, DSMENSCFOP, DTVALIDCFOP,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFEALIQ
                                           WHEN '6' THEN IDDIFEALIQ
                                           ELSE NULL END AS IDDIFEALIQ,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFALIQCUSPR
                                           WHEN '6' THEN IDDIFALIQCUSPR
                                           ELSE 'N' END AS IDDIFALIQCUSPR,
                         CDMENSAGEM
                  FROM CODFISCOPER C LEFT JOIN MENSCFOP M ON
                       (C.NRINCIDCFOP  = M.NRINCIDCFOP)
                  WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP) AND
                        (C.CDEMPRESA    = @P_EMPRESA)    AND
                        (C.CDTIPOOPER   = @P_TIPOOPER)   AND
                        (C.CDINSCESTA   = @P_INSCESTA)   AND
                        (C.CDGRUPOFISC IS NULL)          AND
                        (C.IDCFOPINTEREST = 'S')         AND
                        (C.CDPRODUTO IS NULL)            AND
                        (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                            FROM CODFISCOPER C
                                            WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)     AND
                                                  (C.CDEMPRESA    = @P_EMPRESA)        AND
                                                  (C.CDTIPOOPER   = @P_TIPOOPER)       AND
                                                  (C.CDINSCESTA   = @P_INSCESTA)       AND
                                                  (C.CDGRUPOFISC  IS NULL)             AND
                                                  (C.IDCFOPINTEREST = 'S')             AND
                                                  (C.CDPRODUTO    IS NULL)             AND
                                                  (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
               OPEN C_CFOPNULL;
               FETCH NEXT FROM C_CFOPNULL INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                               @V_DTVALIDCFOP, @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                               @V_CDMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSCFOP = NULL;
                  END;

                  INSERT INTO CFOPTEMP(NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                                       DSCFOPTMP, DSMENSCFOTMP, DTVDCFOPTMP, IDDIFALIQTMP,
                                       IDDIFALIQCUSPRC)
                  VALUES(@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_CFOP1DIGT+@V_CDFISCOPER, @V_CDSUFXCFOP,
                         @V_DSCDFISCOPER, @V_DSMENSCFOP, @V_DTVALIDCFOP, @V_IDDIFEALIQ,
                         @V_IDDIFALIQCUSPR);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_CFOPNULL INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                                  @V_DTVALIDCFOP, @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                                  @V_CDMENSAGEM;
               END;
               CLOSE C_CFOPNULL;
               DEALLOCATE C_CFOPNULL;
            END;
         END;
      END;
      /*-------------------------------------------------------------------------------------------------*/
      SELECT @V_CONTADOR = COUNT(*)
        FROM CFOPTEMP
       WHERE NRCFOPTEMP = @P_FILIAL+@P_LANCTONF;

      IF @V_CONTADOR = 0 BEGIN
         SET @V_IDINTEREST = 'N';
      END;

      IF @V_IDINTEREST = 'N' BEGIN
         IF (@V_CDGRUPOFISC IS NOT NULL) BEGIN
            IF @P_CDARVPROD IS NOT NULL BEGIN
               SELECT @V_CDARVPROD = MAX(P.CDARVPROD),
                      @V_CONTADOR  = COUNT(*)
               FROM CODFISCOPER C LEFT JOIN PRODUTO P ON
                                 (C.CDPRODUTO   = P.CDPRODUTO)
               WHERE (IDENTSAICFOP = @P_ENTSAICFOP)  AND
                     (CDEMPRESA    = @P_EMPRESA)     AND
                     (CDTIPOOPER   = @P_TIPOOPER)    AND
                     (CDINSCESTA   = @P_INSCESTA)    AND
                     (CDGRUPOFISC  = @V_CDGRUPOFISC) AND
                     (IDCFOPINTEREST = 'N')          AND
                     (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),@P_CDARVPROD),@P_CDARVPROD) = 1);
            END
            ELSE BEGIN
               SELECT @V_CDARVPROD = MAX(C.CDPRODUTO),
                      @V_CONTADOR  = COUNT(*)
               FROM CODFISCOPER C
               WHERE (IDENTSAICFOP = @P_ENTSAICFOP)  AND
                     (CDEMPRESA    = @P_EMPRESA)     AND
                     (CDTIPOOPER   = @P_TIPOOPER)    AND
                     (CDINSCESTA   = @P_INSCESTA)    AND
                     (CDGRUPOFISC  = @V_CDGRUPOFISC) AND
                     (IDCFOPINTEREST = 'N')          AND
                     (CDPRODUTO IS NULL);
            END;
         END;

         IF (@V_CONTADOR > 0) BEGIN
            IF (NOT @V_CDARVPROD IS NULL) BEGIN
               DECLARE C_CFOP CURSOR FOR
                  SELECT CDFISCOPER, DSCDFISCOPER, CDSUFXCFOP, DSMENSCFOP,DTVALIDCFOP,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFEALIQ
                                           WHEN '6' THEN IDDIFEALIQ
                                           ELSE NULL END AS IDDIFEALIQ,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFALIQCUSPR
                                           WHEN '6' THEN IDDIFALIQCUSPR
                                           ELSE 'N' END AS IDDIFALIQCUSPR,
                         CDMENSAGEM
                  FROM CODFISCOPER C LEFT JOIN MENSCFOP M ON
                                   (C.NRINCIDCFOP  = M.NRINCIDCFOP)
                                     LEFT JOIN PRODUTO P ON
                                   (C.CDPRODUTO    = P.CDPRODUTO)
                  WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)     AND
                        (C.CDEMPRESA    = @P_EMPRESA)        AND
                        (C.CDTIPOOPER   = @P_TIPOOPER)       AND
                        (C.CDINSCESTA   = @P_INSCESTA)       AND
                        (C.CDGRUPOFISC  = @V_CDGRUPOFISC)    AND
                        (C.IDCFOPINTEREST = 'N')             AND
                        (P.CDARVPROD    = @V_CDARVPROD)      AND
                        (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                            FROM CODFISCOPER C  LEFT JOIN PRODUTO P
                                               ON (C.CDPRODUTO = P.CDPRODUTO)
                                            WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)     AND
                                                  (C.CDEMPRESA    = @P_EMPRESA)        AND
                                                  (C.CDTIPOOPER   = @P_TIPOOPER)       AND
                                                  (C.CDINSCESTA   = @P_INSCESTA)       AND
                                                  (C.CDGRUPOFISC  = @V_CDGRUPOFISC)    AND
                                                  (C.IDCFOPINTEREST = 'N')             AND
                                                  (P.CDARVPROD    = @V_CDARVPROD)      AND
                                                  (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
               OPEN C_CFOP;
               FETCH NEXT FROM C_CFOP INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                           @V_DTVALIDCFOP,  @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                           @V_CDMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSCFOP = NULL;
                  END;

                  INSERT INTO CFOPTEMP(NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                                       DSCFOPTMP, DSMENSCFOTMP, DTVDCFOPTMP, IDDIFALIQTMP,
                                       IDDIFALIQCUSPRC)
                  VALUES(@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA,@V_CFOP1DIGT+@V_CDFISCOPER, @V_CDSUFXCFOP,
                         @V_DSCDFISCOPER, @V_DSMENSCFOP, @V_DTVALIDCFOP, @V_IDDIFEALIQ,
                         @V_IDDIFALIQCUSPR);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_CFOP INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                              @V_DTVALIDCFOP,  @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                              @V_CDMENSAGEM;
               END;
               CLOSE C_CFOP;
               DEALLOCATE C_CFOP;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_CFOPNULL CURSOR FOR
                  SELECT CDFISCOPER, DSCDFISCOPER, CDSUFXCFOP, DSMENSCFOP, DTVALIDCFOP,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFEALIQ
                                           WHEN '6' THEN IDDIFEALIQ
                                           ELSE NULL END AS IDDIFEALIQ,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFALIQCUSPR
                                        WHEN '6' THEN IDDIFALIQCUSPR
                                        ELSE 'N' END AS IDDIFALIQCUSPR,
                         CDMENSAGEM
                  FROM CODFISCOPER C LEFT JOIN MENSCFOP M ON
                       (C.NRINCIDCFOP  = M.NRINCIDCFOP)
                  WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)  AND
                        (C.CDEMPRESA    = @P_EMPRESA)     AND
                        (C.CDTIPOOPER   = @P_TIPOOPER)    AND
                        (C.CDINSCESTA   = @P_INSCESTA)    AND
                        (C.CDGRUPOFISC  = @V_CDGRUPOFISC) AND
                        (C.IDCFOPINTEREST = 'N')          AND
                        (C.CDPRODUTO IS NULL)             AND
                        (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                            FROM CODFISCOPER C
                                            WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)     AND
                                                  (C.CDEMPRESA    = @P_EMPRESA)        AND
                                                  (C.CDTIPOOPER   = @P_TIPOOPER)       AND
                                                  (C.CDINSCESTA   = @P_INSCESTA)       AND
                                                  (C.CDGRUPOFISC  = @V_CDGRUPOFISC)    AND
                                                  (C.IDCFOPINTEREST = 'N')             AND
                                                  (C.CDPRODUTO   IS NULL)              AND
                                                  (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
               OPEN C_CFOPNULL;
               FETCH NEXT FROM C_CFOPNULL INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                               @V_DTVALIDCFOP,  @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                               @V_CDMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSCFOP = NULL;
                  END;

                  INSERT INTO CFOPTEMP(NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                                       DSCFOPTMP, DSMENSCFOTMP, DTVDCFOPTMP, IDDIFALIQTMP,
                                       IDDIFALIQCUSPRC)
                  VALUES(@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_CFOP1DIGT+@V_CDFISCOPER, @V_CDSUFXCFOP,
                         @V_DSCDFISCOPER, @V_DSMENSCFOP, @V_DTVALIDCFOP, @V_IDDIFEALIQ,
                         @V_IDDIFALIQCUSPR);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_CFOPNULL INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                               @V_DTVALIDCFOP,  @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                               @V_CDMENSAGEM;
               END;
               CLOSE C_CFOPNULL;
               DEALLOCATE C_CFOPNULL;
            END;

         END
         ELSE BEGIN
            IF @P_CDARVPROD IS NOT NULL BEGIN
               SELECT @V_CDARVPROD = MAX(P.CDARVPROD)
               FROM CODFISCOPER C LEFT JOIN PRODUTO P ON
                                 (C.CDPRODUTO = P.CDPRODUTO)
               WHERE (IDENTSAICFOP = @P_ENTSAICFOP) AND
                     (CDEMPRESA    = @P_EMPRESA)    AND
                     (CDTIPOOPER   = @P_TIPOOPER)   AND
                     (CDINSCESTA   = @P_INSCESTA)   AND
                     (CDGRUPOFISC IS NULL)          AND
                     (IDCFOPINTEREST = 'N')         AND
                     (CHARINDEX(ISNULL(RTRIM(P.CDARVPROD),@P_CDARVPROD),@P_CDARVPROD) = 1);
            END
            ELSE BEGIN
               SELECT @V_CDARVPROD = MAX(C.CDPRODUTO)
               FROM CODFISCOPER C
               WHERE (IDENTSAICFOP = @P_ENTSAICFOP) AND
                     (CDEMPRESA    = @P_EMPRESA)    AND
                     (CDTIPOOPER   = @P_TIPOOPER)   AND
                     (CDINSCESTA   = @P_INSCESTA)   AND
                     (CDGRUPOFISC IS NULL)          AND
                     (IDCFOPINTEREST = 'N')         AND
                     (C.CDPRODUTO IS NULL);
            END;
            IF NOT (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_CFOP CURSOR FOR
                   SELECT CDFISCOPER, DSCDFISCOPER, CDSUFXCFOP, DSMENSCFOP ,DTVALIDCFOP,
                          CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFEALIQ
                                            WHEN '6' THEN IDDIFEALIQ
                                            ELSE NULL END AS IDDIFEALIQ,
                          CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFALIQCUSPR
                                            WHEN '6' THEN IDDIFALIQCUSPR
                                            ELSE 'N' END AS IDDIFALIQCUSPR,
                          CDMENSAGEM
                   FROM CODFISCOPER C LEFT JOIN MENSCFOP M ON
                                    (C.NRINCIDCFOP  = M.NRINCIDCFOP)
                                      LEFT JOIN PRODUTO P ON
                                    (C.CDPRODUTO = P.CDPRODUTO)
                   WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP) AND
                         (C.CDEMPRESA    = @P_EMPRESA)    AND
                         (C.CDTIPOOPER   = @P_TIPOOPER)   AND
                         (C.CDINSCESTA   = @P_INSCESTA)   AND
                         (C.CDGRUPOFISC IS NULL)          AND
                         (C.IDCFOPINTEREST = 'N')         AND
                         (P.CDARVPROD    = @V_CDARVPROD)  AND
                         (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                            FROM CODFISCOPER C LEFT JOIN PRODUTO P
                                            ON    (C.CDPRODUTO    = P.CDPRODUTO)
                                            WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)     AND
                                                  (C.CDEMPRESA    = @P_EMPRESA)        AND
                                                  (C.CDTIPOOPER   = @P_TIPOOPER)       AND
                                                  (C.CDINSCESTA   = @P_INSCESTA)       AND
                                                  (C.CDGRUPOFISC  IS NULL)             AND
                                                  (C.IDCFOPINTEREST = 'N')             AND
                                                  (P.CDARVPROD    = @V_CDARVPROD)      AND
                                                  (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
               OPEN C_CFOP;
               FETCH NEXT FROM C_CFOP INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                           @V_DTVALIDCFOP, @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                           @V_CDMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSCFOP = NULL;
                  END;

                  INSERT INTO CFOPTEMP(NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                                       DSCFOPTMP, DSMENSCFOTMP,DTVDCFOPTMP, IDDIFALIQTMP,
                                       IDDIFALIQCUSPRC)
                  VALUES(@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_CFOP1DIGT+@V_CDFISCOPER, @V_CDSUFXCFOP,
                         @V_DSCDFISCOPER, @V_DSMENSCFOP, @V_DTVALIDCFOP, @V_IDDIFEALIQ,
                         @V_IDDIFALIQCUSPR);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_CFOP INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                           @V_DTVALIDCFOP, @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                           @V_CDMENSAGEM;
               END;
               CLOSE C_CFOP;
               DEALLOCATE C_CFOP;
            END
            ELSE IF (@V_CDARVPROD IS NULL) BEGIN
               DECLARE C_CFOPNULL CURSOR FOR
                  SELECT CDFISCOPER, DSCDFISCOPER, CDSUFXCFOP, DSMENSCFOP, DTVALIDCFOP,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFEALIQ
                                           WHEN '6' THEN IDDIFEALIQ
                                           ELSE NULL END AS IDDIFEALIQ,
                         CASE @V_CFOP1DIGT WHEN '2' THEN IDDIFALIQCUSPR
                                           WHEN '6' THEN IDDIFALIQCUSPR
                                           ELSE 'N' END AS IDDIFALIQCUSPR,
                         CDMENSAGEM
                  FROM CODFISCOPER C LEFT JOIN MENSCFOP M ON
                       (C.NRINCIDCFOP  = M.NRINCIDCFOP)
                  WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP) AND
                        (C.CDEMPRESA    = @P_EMPRESA)    AND
                        (C.CDTIPOOPER   = @P_TIPOOPER)   AND
                        (C.CDINSCESTA   = @P_INSCESTA)   AND
                        (C.CDGRUPOFISC IS NULL)          AND
                        (C.IDCFOPINTEREST = 'N')         AND
                        (C.CDPRODUTO IS NULL)            AND
                        (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                            FROM CODFISCOPER C
                                            WHERE (C.IDENTSAICFOP = @P_ENTSAICFOP)     AND
                                                  (C.CDEMPRESA    = @P_EMPRESA)        AND
                                                  (C.CDTIPOOPER   = @P_TIPOOPER)       AND
                                                  (C.CDINSCESTA   = @P_INSCESTA)       AND
                                                  (C.CDGRUPOFISC  IS NULL)             AND
                                                  (C.IDCFOPINTEREST = 'N')             AND
                                                  (C.CDPRODUTO    IS NULL)             AND
                                                  (C.DTVALIDCFOP <= @P_DTVALIDCFOP)));
               OPEN C_CFOPNULL;
               FETCH NEXT FROM C_CFOPNULL INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                               @V_DTVALIDCFOP, @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                               @V_CDMENSAGEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_COUNTMENS = COUNT(*)
                    FROM MENSAGEM
                   WHERE CDMENSAGEM = @V_CDMENSAGEM
                     AND IDSITUACAOMENS = 'I';

                  IF @V_COUNTMENS > 0 BEGIN
                     SET @V_DSMENSCFOP = NULL;
                  END;

                  INSERT INTO CFOPTEMP(NRCFOPTEMP, NRSEQUCFOP, CDFISOPETMP, CDSUFCFOPTMP,
                                       DSCFOPTMP, DSMENSCFOTMP, DTVDCFOPTMP, IDDIFALIQTMP,
                                       IDDIFALIQCUSPRC)
                  VALUES(@P_FILIAL+@P_LANCTONF, @V_SEQUENCIA, @V_CFOP1DIGT+@V_CDFISCOPER, @V_CDSUFXCFOP,
                         @V_DSCDFISCOPER, @V_DSMENSCFOP, @V_DTVALIDCFOP, @V_IDDIFEALIQ,
                         @V_IDDIFALIQCUSPR);

                  SET @V_SEQUENCIA = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR, CONVERT(INT,@V_SEQUENCIA) + 1)),2);

                  FETCH NEXT FROM C_CFOPNULL INTO @V_CDFISCOPER, @V_DSCDFISCOPER, @V_CDSUFXCFOP, @V_DSMENSCFOP,
                                                  @V_DTVALIDCFOP, @V_IDDIFEALIQ, @V_IDDIFALIQCUSPR,
                                                  @V_CDMENSAGEM;
               END;
               CLOSE C_CFOPNULL;
               DEALLOCATE C_CFOPNULL;
            END;
         END;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CONSULTA_CFOP','5.85.xxx';
GO

