/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MOTORISTA                                                */
/* Tabela : MOTORISTA                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 03/02/2015 - Gleydson Israel da Silva Gazola                               */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'DTULTATU_MOTORISTA' 
             AND TYPE = 'TR'
             AND U.UID = O.UID
             AND U.NAME = USER)
   DROP TRIGGER DTULTATU_MOTORISTA
GO

CREATE TRIGGER DTULTATU_MOTORISTA
ON MOTORISTA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE 
         (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
         (SELECT 'MOTORISTA', null, 'CDMOTORISTA=' + CDMOTORISTA+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MOTORISTA
         SET DTULTATUMOTOR = GETDATE()
      FROM INSERTED;
   END;
END;
GO

